#include <types.h>

#include <base.h>
#include <vdp.h>
#include <vdp_tile.h>

#ifdef DEBUG
#include "utils/debug.h"
#endif

volatile u8 	ResetState;
volatile u8 	PauseState;


extern u32 get_pad( );
extern BOOL get_multitap( );

BOOL isMultiPlayer;

static void VBlank_sub( )
{
	//(0001 MXYZ SACB RLDU) or (0000 0000 SACB RLDU)

	if (isMultiPlayer)
	{
		volatile u8 *pb;

		pb = (u8 *) 0xa10005;
		*pb = 0x0c;
	}

	u32 pad1 = get_pad( 0xA10003  );

#ifdef DEBUG
	Debug_AlertNumber( pad1  );
#endif

	if (pad1 & 0x1000)
	{
		VDP_drawText(APLAN, "6 btn pad", TILE_FONTINDEX,0,0);
	}
	else
	{
		VDP_drawText(APLAN, "3 btn pad", TILE_FONTINDEX,0,0);
	}

	//A
	if (pad1 & 0x0040)
	{
		VDP_drawText(APLAN, "A pressed ", TILE_FONTINDEX,0,1);
	}
	else
	{
		VDP_drawText(APLAN, "A released", TILE_FONTINDEX,0,1);
	}

}

int main( )
{
	PauseState = 0;
	ResetState = 0;

	VDP_setReg(0, 0x04);   /* reg. 0 - disEnable HBL */
	//VDP_setReg(1, 0x74);   /* reg. 1 - Enable display, VBL, DMA + VCell size (28) */
	//VDP_setReg(2, 0x30);   /* reg. 2 - Plane A =$30*$400=$C000 */
	//VDP_setReg(3, 0x2C);   /* reg. 3 - Window  =$2C*$400=$B000 */
	//VDP_setReg(4, 0x07);   /* reg. 4 - Plane B =$7*$2000=$E000 */
	//VDP_setReg(5, 0x5F);   /* reg. 5 - sprite table begins at $BE00=$5F*$200 */
	//VDP_setReg(6, 0x00);   /* reg. 6 - not used */
	//VDP_setReg(7, 0x00);   /* reg. 7 - Background Color number*/
	//VDP_setReg(8, 0x00);   /* reg. 8 - not used */
	//VDP_setReg(9, 0x00);   /* reg. 9 - not used */
	VDP_setReg(10, 0x00);   /* reg 10 - HInterrupt timing */
	VDP_setReg(11, 0x00);   /* reg 11 - $0000abcd a=extr.int b=vscr cd=hscr */
	VDP_setReg(12, 0x00);   /* reg 12 - hcell mode + shadow/highight + interlaced mode */
	//VDP_setReg(13, 0x2E);   /* reg 13 - HScoll Table = $B800 */
	//VDP_setReg(14, 0x00);   /* reg 14 - not used */
	//VDP_setReg(15, 0x02);   /* reg 15 - auto increment data */
	VDP_setReg(16, 0x10);   /* reg 16 - scrl screen v&h size */
	//VDP_setReg(17, 0x00);   /* reg 17 - window hpos */

	VDP_drawText(APLAN, "youyou", TILE_FONTINDEX,0,0);

	setVBlankCallback( &VBlank_sub );

	if ( get_multitap() )
	{
		isMultiPlayer = 0;
		VDP_drawText(APLAN, "Multitap not found", TILE_FONTINDEX,0,20);
	}
	else
	{
		isMultiPlayer = 1;
		VDP_drawText(APLAN, "Multitap found", TILE_FONTINDEX,0,20);
	}


	while(1)
	{
		VDP_waitVSync();
	}
	return (0);
}
